# TerminalCalendar

[![Build Status](https://github.com/DimitarVanguelov/TerminalCalendar.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/DimitarVanguelov/TerminalCalendar.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Project Status: WIP – Initial development is in progress, but there has not yet been a stable, usable release suitable for the public.](https://www.repostatus.org/badges/latest/wip.svg)](https://www.repostatus.org/#wip)

![](assets/all-the-dates.png)

A simple package to view dates in monthly calendar format from the comfort of your REPL. 
Built on top of [PrettyTables.jl](https://github.com/ronisbr/PrettyTables.jl) with some 
help from Ronan Arraes Jardim Chagas (aka @ronisbr)

## Installation

This package isn't registered yet, so just install by pointing to this repo:

```julia
] add [this repo]
```

## Usage

There is only a single exported function `calendar`. In it's most basic form, it takes two 
`Int` values for year and month:

```julia
julia> calendar(2021, 12)

              December 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │   1 │   2 │   3 │   4 │   5 │
│   6 │   7 │   8 │   9 │  10 │  11 │  12 │
│  13 │  14 │  15 │  16 │  17 │  18 │  19 │
│  20 │  21 │  22 │  23 │  24 │  25 │  26 │
│  27 │  28 │  29 │  30 │  31 │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘
```

You can also input a `Date` object (after importing `Dates`):

```julia
julia> calendar(Date(2021, 12))

              December 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │   1 │   2 │   3 │   4 │   5 │
│   6 │   7 │   8 │   9 │  10 │  11 │  12 │
│  13 │  14 │  15 │  16 │  17 │  18 │  19 │
│  20 │  21 │  22 │  23 │  24 │  25 │  26 │
│  27 │  28 │  29 │  30 │  31 │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘
```

You can get the calendar for a whole year simply by inputting a single `Int`:

```julia
julia> calendar(2021)

               January 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │     │     │   1 │   2 │   3 │
│   4 │   5 │   6 │   7 │   8 │   9 │  10 │
│  11 │  12 │  13 │  14 │  15 │  16 │  17 │
│  18 │  19 │  20 │  21 │  22 │  23 │  24 │
│  25 │  26 │  27 │  28 │  29 │  30 │  31 │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

              February 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│   1 │   2 │   3 │   4 │   5 │   6 │   7 │
│   8 │   9 │  10 │  11 │  12 │  13 │  14 │
│  15 │  16 │  17 │  18 │  19 │  20 │  21 │
│  22 │  23 │  24 │  25 │  26 │  27 │  28 │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

                March 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│   1 │   2 │   3 │   4 │   5 │   6 │   7 │
│   8 │   9 │  10 │  11 │  12 │  13 │  14 │
│  15 │  16 │  17 │  18 │  19 │  20 │  21 │
│  22 │  23 │  24 │  25 │  26 │  27 │  28 │
│  29 │  30 │  31 │     │     │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

                April 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │     │   1 │   2 │   3 │   4 │
│   5 │   6 │   7 │   8 │   9 │  10 │  11 │
│  12 │  13 │  14 │  15 │  16 │  17 │  18 │
│  19 │  20 │  21 │  22 │  23 │  24 │  25 │
│  26 │  27 │  28 │  29 │  30 │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

                 May 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │     │     │     │   1 │   2 │
│   3 │   4 │   5 │   6 │   7 │   8 │   9 │
│  10 │  11 │  12 │  13 │  14 │  15 │  16 │
│  17 │  18 │  19 │  20 │  21 │  22 │  23 │
│  24 │  25 │  26 │  27 │  28 │  29 │  30 │
│  31 │     │     │     │     │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

                June 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │   1 │   2 │   3 │   4 │   5 │   6 │
│   7 │   8 │   9 │  10 │  11 │  12 │  13 │
│  14 │  15 │  16 │  17 │  18 │  19 │  20 │
│  21 │  22 │  23 │  24 │  25 │  26 │  27 │
│  28 │  29 │  30 │     │     │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

                July 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │     │   1 │   2 │   3 │   4 │
│   5 │   6 │   7 │   8 │   9 │  10 │  11 │
│  12 │  13 │  14 │  15 │  16 │  17 │  18 │
│  19 │  20 │  21 │  22 │  23 │  24 │  25 │
│  26 │  27 │  28 │  29 │  30 │  31 │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

               August 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │     │     │     │     │   1 │
│   2 │   3 │   4 │   5 │   6 │   7 │   8 │
│   9 │  10 │  11 │  12 │  13 │  14 │  15 │
│  16 │  17 │  18 │  19 │  20 │  21 │  22 │
│  23 │  24 │  25 │  26 │  27 │  28 │  29 │
│  30 │  31 │     │     │     │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

              September 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │   1 │   2 │   3 │   4 │   5 │
│   6 │   7 │   8 │   9 │  10 │  11 │  12 │
│  13 │  14 │  15 │  16 │  17 │  18 │  19 │
│  20 │  21 │  22 │  23 │  24 │  25 │  26 │
│  27 │  28 │  29 │  30 │     │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

               October 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │     │     │   1 │   2 │   3 │
│   4 │   5 │   6 │   7 │   8 │   9 │  10 │
│  11 │  12 │  13 │  14 │  15 │  16 │  17 │
│  18 │  19 │  20 │  21 │  22 │  23 │  24 │
│  25 │  26 │  27 │  28 │  29 │  30 │  31 │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

              November 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│   1 │   2 │   3 │   4 │   5 │   6 │   7 │
│   8 │   9 │  10 │  11 │  12 │  13 │  14 │
│  15 │  16 │  17 │  18 │  19 │  20 │  21 │
│  22 │  23 │  24 │  25 │  26 │  27 │  28 │
│  29 │  30 │     │     │     │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

              December 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │   1 │   2 │   3 │   4 │   5 │
│   6 │   7 │   8 │   9 │  10 │  11 │  12 │
│  13 │  14 │  15 │  16 │  17 │  18 │  19 │
│  20 │  21 │  22 │  23 │  24 │  25 │  26 │
│  27 │  28 │  29 │  30 │  31 │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘
```

You can also pass in ranges:

```julia
julia> calendar(2021, 10:12)

               October 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │     │     │   1 │   2 │   3 │
│   4 │   5 │   6 │   7 │   8 │   9 │  10 │
│  11 │  12 │  13 │  14 │  15 │  16 │  17 │
│  18 │  19 │  20 │  21 │  22 │  23 │  24 │
│  25 │  26 │  27 │  28 │  29 │  30 │  31 │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

              November 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│   1 │   2 │   3 │   4 │   5 │   6 │   7 │
│   8 │   9 │  10 │  11 │  12 │  13 │  14 │
│  15 │  16 │  17 │  18 │  19 │  20 │  21 │
│  22 │  23 │  24 │  25 │  26 │  27 │  28 │
│  29 │  30 │     │     │     │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

              December 2021
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │   1 │   2 │   3 │   4 │   5 │
│   6 │   7 │   8 │   9 │  10 │  11 │  12 │
│  13 │  14 │  15 │  16 │  17 │  18 │  19 │
│  20 │  21 │  22 │  23 │  24 │  25 │  26 │
│  27 │  28 │  29 │  30 │  31 │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘
```

and vectors of dates:

```julia
julia> febs = lastdayofmonth.(Date(2010, 2):Year(1):Date(2020, 2));
julia> leap_febs = filter(x -> day(x) == 29, febs)
6-element Vector{Date}:
 2012-02-29
 2016-02-29
 2020-02-29

julia> calendar(leap_febs)

              February 2012
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │   1 │   2 │   3 │   4 │   5 │
│   6 │   7 │   8 │   9 │  10 │  11 │  12 │
│  13 │  14 │  15 │  16 │  17 │  18 │  19 │
│  20 │  21 │  22 │  23 │  24 │  25 │  26 │
│  27 │  28 │  29 │     │     │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

              February 2016
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│   1 │   2 │   3 │   4 │   5 │   6 │   7 │
│   8 │   9 │  10 │  11 │  12 │  13 │  14 │
│  15 │  16 │  17 │  18 │  19 │  20 │  21 │
│  22 │  23 │  24 │  25 │  26 │  27 │  28 │
│  29 │     │     │     │     │     │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘

              February 2020
┌─────┬─────┬─────┬─────┬─────┬─────┬─────┐
│ Mon │ Tue │ Wed │ Thu │ Fri │ Sat │ Sun │
├─────┼─────┼─────┼─────┼─────┼─────┼─────┤
│     │     │     │     │     │   1 │   2 │
│   3 │   4 │   5 │   6 │   7 │   8 │   9 │
│  10 │  11 │  12 │  13 │  14 │  15 │  16 │
│  17 │  18 │  19 │  20 │  21 │  22 │  23 │
│  24 │  25 │  26 │  27 │  28 │  29 │     │
└─────┴─────┴─────┴─────┴─────┴─────┴─────┘
```

And there is more, just play around with it and see what works! 

## Development

This package is mostly just fun and learning. If you have ideas 
for improvement, please let me know either on GitHub or Slack, 
and if I have time, I will certainly look into it. 
